/*********************************************************************/
/*                    Programm DESUDO.cc                             */
/*********************************************************************/
/*                                                                   */
/*           Dieses Programm ist hiermit unter der                   */
/*     GPL (General Public License, www.gnu.org) freigegeben         */
/*                                                                   */
/*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#include <curses.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>
#include <sys/stat.h>
//#include <dos.h>
//#include "hilfen01.h"
//#include "eingabe.h"
#include "zufall.h"
                   
#define vpf v_printf
#define zw  v_printf("\n")
#define gxy v_gotoxy
                  

// Prototypen
int zuf(int ta);

// Globale Variable
unsigned char f[9][9], g[9][9], p[9][9];
char *tzstr="TZ=PST8PDT";


int main(void)
{
   int a,i,j,n,ta;
   struct timeb t;
   
   putenv(tzstr);
   tzset();

initscr();
start_color();
init_pair(1,COLOR_WHITE, COLOR_BLACK);
init_pair(2,COLOR_RED,COLOR_BLACK);
init_pair(3,COLOR_GREEN,COLOR_BLACK);
init_pair(4,COLOR_CYAN,COLOR_BLACK);
init_pair(5,COLOR_YELLOW,COLOR_BLACK);
init_pair(6,COLOR_MAGENTA,COLOR_BLACK);
init_pair(7,COLOR_BLUE,COLOR_BLACK);

//attron(A_BOLD);
mvprintw(10,15, "Dieses Programm ist fuer die Textkonsole gedacht,");
mvprintw(11,15, "weil virtuelle Konsolen oft nicht geeignet sind.");
mvprintw(12,13, "(Die Gruende dafuer durchschaue ich noch nicht ganz.)");
//attroff(A_BOLD);

mvprintw(15,16, "    #           ####   #    #  ####     ##### ");
mvprintw(16,16, "    #          #       #    #  #   #   #     #");
mvprintw(17,16, " ####   ####    ####   #    #  #    #  #     #");
mvprintw(18,16, "#   #  ## ###       #  #    #  #    #  #     #");
mvprintw(19,16, "#   #  ##           #  #    #  #   #   #     #");
mvprintw(20,16, " ####   ###     ####    ####   ####     ##### ");
mvprintw(23,10, "Ein Programm zum Erzeugen und Ausdrucken von SUDOKU-Raetseln");
mvprintw(24,10, "===========================================================");
mvprintw(26, 8, "!!! Dieses Programm kann nur mit der Tastatur bedient werden !!!");
mvprintw(27, 8, "              !!! Die Maus ist ");
move(27,39);
attron(COLOR_PAIR(2));
addstr("nicht");
attron(COLOR_PAIR(1));
move(27,44);
addstr(" anwendbar !!!");
mvprintw(28, 8, "Um die gewuenschte Reaktion des Programms zu bewirken, genuegt es,");
mvprintw(29, 8, "die Taste fuer den dazu erforderlichen Buchstaben zu druecken;");
mvprintw(30, 8, "die Betaetigung der Eingabetaste ist ");
move(30,45);
attron(COLOR_PAIR(4));
addstr("nicht mehr");
attron(COLOR_PAIR(1));
move(30,55);
addstr(" erforderlich.");

mvprintw(31, 8, "(Die Eingabetaste ist ");
move(31,30);
attron(COLOR_PAIR(3)); //attron(A_BOLD);  //  diese Funktionen attron(A_BOLD) und
addstr("nur");
        //attroff(A_BOLD); //  attroff(A_BOLD) wirken nur bei der Farbe YELLOW
attron(COLOR_PAIR(1));
move(31,33);
addstr(" nach der Zahleneingabe zu betaetigen.)");
mvprintw(33, 8, "Es gibt Menschen, denen Buchstaben sympatischer als Zahlen sind.");
mvprintw(34, 8, "Mit dem folgenden Programm koennen Sie SUDOKU-Raetsel erzeugen,");
mvprintw(35, 8, "fuer deren Felder zwei Arten von Symbolen waehlbar sind,");
mvprintw(36, 8, "naemlich entweder Buchstaben (A bis I) oder Zahlen (1 bis 9).");
mvprintw(37, 8, "Moechten Sie fuer das folgende SUDOKU-Raetsel als Symbole");
mvprintw(38, 8, "Buchstaben? (b) oder Zahlen (z) waehlen? ");


//getch();


unsigned char entZB;
ENTZB:
move(38,49);
addstr(" ");
move(38,49);
entZB=getch();
switch(entZB)
{
  case 'z' : goto weiter; break;
  case 'b' : goto weiter; break;
  default  : goto ENTZB;  break;
}
   
/* Sicherheits-Version der Daten eines SUDOKU-Gesamtfeldes; nicht verndern! */
/* Diese Zahlenwerte entsprechen den SUDOKU-Regeln.                          */
/*
f[0][0]=8; f[0][1]=7; f[0][2]=5; f[0][3]=1; f[0][4]=9; f[0][5]=6; f[0][6]=3; f[0][7]=4; f[0][8]=2;    
f[1][0]=2; f[1][1]=3; f[1][2]=1; f[1][3]=7; f[1][4]=8; f[1][5]=4; f[1][6]=5; f[1][7]=9; f[1][8]=6;    
f[2][0]=9; f[2][1]=4; f[2][2]=6; f[2][3]=2; f[2][4]=3; f[2][5]=5; f[2][6]=1; f[2][7]=8; f[2][8]=7;    
f[3][0]=1; f[3][1]=2; f[3][2]=9; f[3][3]=3; f[3][4]=6; f[3][5]=8; f[3][6]=7; f[3][7]=5; f[3][8]=4;    
f[4][0]=5; f[4][1]=6; f[4][2]=3; f[4][3]=4; f[4][4]=2; f[4][5]=7; f[4][6]=9; f[4][7]=1; f[4][8]=8;    
f[5][0]=4; f[5][1]=8; f[5][2]=7; f[5][3]=5; f[5][4]=1; f[5][5]=9; f[5][6]=6; f[5][7]=2; f[5][8]=3;    
f[6][0]=3; f[6][1]=5; f[6][2]=4; f[6][3]=8; f[6][4]=7; f[6][5]=1; f[6][6]=2; f[6][7]=6; f[6][8]=9;    
f[7][0]=6; f[7][1]=1; f[7][2]=2; f[7][3]=9; f[7][4]=4; f[7][5]=3; f[7][6]=8; f[7][7]=7; f[7][8]=5;    
f[8][0]=7; f[8][1]=9; f[8][2]=8; f[8][3]=6; f[8][4]=5; f[8][5]=2; f[8][6]=4; f[8][7]=3; f[8][8]=1;    
*/

weiter:
vonvorn:
/* Diese (gleichen) Werte werden verwendet */
f[0][0]=8; f[0][1]=7; f[0][2]=5; f[0][3]=1; f[0][4]=9; f[0][5]=6; f[0][6]=3; f[0][7]=4; f[0][8]=2;    
f[1][0]=2; f[1][1]=3; f[1][2]=1; f[1][3]=7; f[1][4]=8; f[1][5]=4; f[1][6]=5; f[1][7]=9; f[1][8]=6;    
f[2][0]=9; f[2][1]=4; f[2][2]=6; f[2][3]=2; f[2][4]=3; f[2][5]=5; f[2][6]=1; f[2][7]=8; f[2][8]=7;    
f[3][0]=1; f[3][1]=2; f[3][2]=9; f[3][3]=3; f[3][4]=6; f[3][5]=8; f[3][6]=7; f[3][7]=5; f[3][8]=4;    
f[4][0]=5; f[4][1]=6; f[4][2]=3; f[4][3]=4; f[4][4]=2; f[4][5]=7; f[4][6]=9; f[4][7]=1; f[4][8]=8;    
f[5][0]=4; f[5][1]=8; f[5][2]=7; f[5][3]=5; f[5][4]=1; f[5][5]=9; f[5][6]=6; f[5][7]=2; f[5][8]=3;    
f[6][0]=3; f[6][1]=5; f[6][2]=4; f[6][3]=8; f[6][4]=7; f[6][5]=1; f[6][6]=2; f[6][7]=6; f[6][8]=9;    
f[7][0]=6; f[7][1]=1; f[7][2]=2; f[7][3]=9; f[7][4]=4; f[7][5]=3; f[7][6]=8; f[7][7]=7; f[7][8]=5;    
f[8][0]=7; f[8][1]=9; f[8][2]=8; f[8][3]=6; f[8][4]=5; f[8][5]=2; f[8][6]=4; f[8][7]=3; f[8][8]=1;    

unsigned char u,n1,n2,z1,s1,z2,s2,z3,s3,z4,s4,z5,s5,u01,u02;
// Beginn der u-Schleife    Programm sololo.cpp
u=1;
do
{ 
  ftime(&t);
  n1=zuf(t.millitm);
//  ftime(&t);
  n2=zuf(t.millitm); 
  if (n1==n2) {goto nnn;}

/* Zunchst fr alle Variablen  f.z.s  Werte z und s vertauschen  */  
// Beginn der z1-Schleife
z1=0;     
do
{
  // Beginn der s1-Schleife
  s1=0; 
  do
  {  
    if (f[z1][s1]==n1) // Wenn f[z1][s1] == n1
    {                  // ist, dann
        p[z1][s1]=n2;  // wird p[z1][s1] der Wert n2 zugewiesen.
    }
    else
    {                        // Wenn f[z1][s1] != n1
        p[z1][s1]=f[z1][s1]; // ist, dann
    }                        // wird p[z1][s1] der Wert f[z1][s1] zugewiesen.


    if (f[z1][s1]==n2) // Wenn f[z1][s1] == n2
    {                  // ist, dann   
        p[z1][s1]=n1;  // wird p[z1][s1] der Wert n1 zugewiesen.
    }
        s1=s1+1;
  } while(s1<=8);
  // Ende der s1-Schleife
  z1=z1+1;
} while(z1<=8);
// Ende der z1-Schleife

// Beginn der z2-Schleife
z2=0;     
do
{
  // Beginn der s2-Schleife
  s2=0;
  do                    
  {       
     f[z2][s2]=p[z2][s2];
     s2=s2+1;
  } while(s2<=8); 
  // Ende der s2-Schleife
  z2=z2+1;
} while(z2<=8); 
// Ende der z2-Schleife 

  u=u+1;
  nnn:
  u=u;
} while(u<=9);
// Ende der u-Schleife

char anz[3];
switch(entZB)
{
  case 'z' : strcpy(anz,"%d"); goto Zahlen;     break;
  case 'b' : strcpy(anz,"%c");                  break;
  default  : break;
}

/* Zunchst Zahlen 1 bis 9 gegen die Buchstaben A bis I tauschen  */  
z3=0;     
do
{
  s3=0; 
  do
  {            
    if (f[z3][s3]==1) {f[z3][s3]='A';} 
    if (f[z3][s3]==2) {f[z3][s3]='B';} 
    if (f[z3][s3]==3) {f[z3][s3]='C';} 
    if (f[z3][s3]==4) {f[z3][s3]='D';} 
    if (f[z3][s3]==5) {f[z3][s3]='E';} 
    if (f[z3][s3]==6) {f[z3][s3]='F';} 
    if (f[z3][s3]==7) {f[z3][s3]='G';} 
    if (f[z3][s3]==8) {f[z3][s3]='H';} 
    if (f[z3][s3]==9) {f[z3][s3]='I';} 
    s3=s3+1;
  } while(s3<=8);
  // Ende der s3-Schleife
  z3=z3+1;
} while(z3<=8);
// Ende der z3-Schleife
 
Zahlen:
mvprintw( 2, 2, "       +======+======+======+======+======+======+======+======+======+");
mvprintw( 3, 2, "       I      |      |      I      |      |      I      |      |      I");
mvprintw( 4, 2, "       I   ");printw(anz,f[0][0]);printw("%s","  |   ");printw(anz,f[0][1]);printw("%s","  |   ");printw(anz,f[0][2]);printw("%s","  I   ");printw(anz,f[0][3]);printw("%s","  |   ");printw(anz,f[0][4]);printw("%s","  |   ");printw(anz,f[0][5]);printw("%s","  I   ");printw(anz,f[0][6]);printw("%s","  |   ");printw(anz,f[0][7]);printw("%s","  |   ");printw(anz,f[0][8]);printw("%s","  I   "); 
mvprintw( 5, 2, "       I      |      |      I      |      |      I      |      |      I");
mvprintw( 6, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw( 7, 2, "       I      |      |      I      |      |      I      |      |      I");
mvprintw( 8, 2, "       I   ");printw(anz,f[1][0]);printw("%s","  |   ");printw(anz,f[1][1]);printw("%s","  |   ");printw(anz,f[1][2]);printw("%s","  I   ");printw(anz,f[1][3]);printw("%s","  |   ");printw(anz,f[1][4]);printw("%s","  |   ");printw(anz,f[1][5]);printw("%s","  I   ");printw(anz,f[1][6]);printw("%s","  |   ");printw(anz,f[1][7]);printw("%s","  |   ");printw(anz,f[1][8]);printw("%s","  I   "); 
mvprintw( 9, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(10, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(11, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(12, 2, "       I   ");printw(anz,f[2][0]);printw("%s","  |   ");printw(anz,f[2][1]);printw("%s","  |   ");printw(anz,f[2][2]);printw("%s","  I   ");printw(anz,f[2][3]);printw("%s","  |   ");printw(anz,f[2][4]);printw("%s","  |   ");printw(anz,f[2][5]);printw("%s","  I   ");printw(anz,f[2][6]);printw("%s","  |   ");printw(anz,f[2][7]);printw("%s","  |   ");printw(anz,f[2][8]);printw("%s","  I   "); 
mvprintw(13, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(14, 2, "       +======+======+======+======+======+======+======+======+======+");
mvprintw(15, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(16, 2, "       I   ");printw(anz,f[3][0]);printw("%s","  |   ");printw(anz,f[3][1]);printw("%s","  |   ");printw(anz,f[3][2]);printw("%s","  I   ");printw(anz,f[3][3]);printw("%s","  |   ");printw(anz,f[3][4]);printw("%s","  |   ");printw(anz,f[3][5]);printw("%s","  I   ");printw(anz,f[3][6]);printw("%s","  |   ");printw(anz,f[3][7]);printw("%s","  |   ");printw(anz,f[3][8]);printw("%s","  I   "); 
mvprintw(17, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(18, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(19, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(20, 2, "       I   ");printw(anz,f[4][0]);printw("%s","  |   ");printw(anz,f[4][1]);printw("%s","  |   ");printw(anz,f[4][2]);printw("%s","  I   ");printw(anz,f[4][3]);printw("%s","  |   ");printw(anz,f[4][4]);printw("%s","  |   ");printw(anz,f[4][5]);printw("%s","  I   ");printw(anz,f[4][6]);printw("%s","  |   ");printw(anz,f[4][7]);printw("%s","  |   ");printw(anz,f[4][8]);printw("%s","  I   "); 
mvprintw(21, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(22, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(23, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(24, 2, "       I   ");printw(anz,f[5][0]);printw("%s","  |   ");printw(anz,f[5][1]);printw("%s","  |   ");printw(anz,f[5][2]);printw("%s","  I   ");printw(anz,f[5][3]);printw("%s","  |   ");printw(anz,f[5][4]);printw("%s","  |   ");printw(anz,f[5][5]);printw("%s","  I   ");printw(anz,f[5][6]);printw("%s","  |   ");printw(anz,f[5][7]);printw("%s","  |   ");printw(anz,f[5][8]);printw("%s","  I   "); 
mvprintw(25, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(26, 2, "       +======+======+======+======+======+======+======+======+======+");
mvprintw(27, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(28, 2, "       I   ");printw(anz,f[6][0]);printw("%s","  |   ");printw(anz,f[6][1]);printw("%s","  |   ");printw(anz,f[6][2]);printw("%s","  I   ");printw(anz,f[6][3]);printw("%s","  |   ");printw(anz,f[6][4]);printw("%s","  |   ");printw(anz,f[6][5]);printw("%s","  I   ");printw(anz,f[6][6]);printw("%s","  |   ");printw(anz,f[6][7]);printw("%s","  |   ");printw(anz,f[6][8]);printw("%s","  I   "); 
mvprintw(29, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(30, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(31, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(32, 2, "       I   ");printw(anz,f[7][0]);printw("%s","  |   ");printw(anz,f[7][1]);printw("%s","  |   ");printw(anz,f[7][2]);printw("%s","  I   ");printw(anz,f[7][3]);printw("%s","  |   ");printw(anz,f[7][4]);printw("%s","  |   ");printw(anz,f[7][5]);printw("%s","  I   ");printw(anz,f[7][6]);printw("%s","  |   ");printw(anz,f[7][7]);printw("%s","  |   ");printw(anz,f[7][8]);printw("%s","  I   "); 
mvprintw(33, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(34, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(35, 2 ,"       I      |      |      I      |      |      I      |      |      I");   
mvprintw(36, 2, "       I   ");printw(anz,f[8][0]);printw("%s","  |   ");printw(anz,f[8][1]);printw("%s","  |   ");printw(anz,f[8][2]);printw("%s","  I   ");printw(anz,f[8][3]);printw("%s","  |   ");printw(anz,f[8][4]);printw("%s","  |   ");printw(anz,f[8][5]);printw("%s","  I   ");printw(anz,f[8][6]);printw("%s","  |   ");printw(anz,f[8][7]);printw("%s","  |   ");printw(anz,f[8][8]);printw("%s","  I   "); 
mvprintw(37, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(38, 2, "       +======+======+======+======+======+======+======+======+======+");
mvprintw(40, 1, "Soll von diesem Sudoku-Gesamtfeld ein SUDOKU-Raetsel erzeugt werden? (j),");
mvprintw(41, 1, "oder soll ein SUDOKU-Gesamtfeld mit anderen (a) Symbolpositionen erzeugt werden?");
mvprintw(42, 1, "oder soll das Programm verlassen werden? (v) ");

unsigned char ent1;
ENT1:
move(42,46);
addstr(" ");
move(42,46);
ent1=getch();
switch(ent1)
{
  case 'j' : goto weiter2;  break;
  case 'a' : goto vonvorn;  break;
  case 'v' : goto PgmEnd;   break;
  default  : goto ENT1; break;
}

weiter2:
//clear();


sudvers: 
clear();
mvprintw(17,12, "Fr ein SUDOKU-Raetsel mssen an zufallsbedingten Stellen"); 
mvprintw(18,12, "des Gesamtfeldes freie Felder erzeugt werden."); 
mvprintw(19,12, "Wie viele freie Felder sollen denn erzeugt werden? "); 


int nl;
char nls[6];
ENT2:
move(19,63);
addstr("                    ");
move(19,63);
getstr(nls);
if (strlen(nls)>2) goto ENT2;
nl=atoi(nls);
if (nl>=80||nl<1) {goto ENT2;}
clear();

zufleer:
/* Zunchst werden alle Variablen g.z.s = f.z.s eingestellt */  
z4=0;     
do
{   
  s4=0; 
  do
  {
    g[z4][s4]=f[z4][s4];
    s4=s4+1;
  } while(s4<=8); // Ende der s4-Schleife
  z4=z4+1;
} while(z4<=8); //Ende der z4-Schleife

/* Erzeugung von nl zufllig angeordneten Leerfeldern fr ein SUDUKO-Rtsel. */              
int wz, ws;
i=1;
do
{   
  strcpy(anz,"%d");
  ftime(&t);
  wz=zuf(t.millitm);
  ftime(&t);
  ws=zuf(t.millitm); 
  z5=wz-1;
  s5=ws-1;
  if (g[z5][s5]==' ') {goto anfi;}
  i=i+1;
  anfi:
  g[z5][s5]=' ';
} while(i<=nl);

/* Nun die Zahlen 1 bis 9 gegen die Variablen '1' bis '9' tauschen  */  
if (entZB=='z')
{
  z3=0;     
  do
  {
    s3=0; 
    do
    {
      if (g[z3][s3]==1) {g[z3][s3]='1';} 
      if (g[z3][s3]==2) {g[z3][s3]='2';} 
      if (g[z3][s3]==3) {g[z3][s3]='3';} 
      if (g[z3][s3]==4) {g[z3][s3]='4';} 
      if (g[z3][s3]==5) {g[z3][s3]='5';} 
      if (g[z3][s3]==6) {g[z3][s3]='6';} 
      if (g[z3][s3]==7) {g[z3][s3]='7';} 
      if (g[z3][s3]==8) {g[z3][s3]='8';} 
      if (g[z3][s3]==9) {g[z3][s3]='9';} 
      s3=s3+1;
    } while(s3<=8);
    // Ende der s3-Schleife
    z3=z3+1;
  } while(z3<=8);
}

strcpy(anz,"%c");
mvprintw( 2, 2, "       +======+======+======+======+======+======+======+======+======+");
mvprintw( 3, 2, "       I      |      |      I      |      |      I      |      |      I");
mvprintw( 4, 2, "       I   ");printw(anz,g[0][0]);printw("%s","  |   ");printw(anz,g[0][1]);printw("%s","  |   ");printw(anz,g[0][2]);printw("%s","  I   ");printw(anz,g[0][3]);printw("%s","  |   ");printw(anz,g[0][4]);printw("%s","  |   ");printw(anz,g[0][5]);printw("%s","  I   ");printw(anz,g[0][6]);printw("%s","  |   ");printw(anz,g[0][7]);printw("%s","  |   ");printw(anz,g[0][8]);printw("%s","  I   "); 
mvprintw( 5, 2, "       I      |      |      I      |      |      I      |      |      I");
mvprintw( 6, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw( 7, 2, "       I      |      |      I      |      |      I      |      |      I");
mvprintw( 8, 2, "       I   ");printw(anz,g[1][0]);printw("%s","  |   ");printw(anz,g[1][1]);printw("%s","  |   ");printw(anz,g[1][2]);printw("%s","  I   ");printw(anz,g[1][3]);printw("%s","  |   ");printw(anz,g[1][4]);printw("%s","  |   ");printw(anz,g[1][5]);printw("%s","  I   ");printw(anz,g[1][6]);printw("%s","  |   ");printw(anz,g[1][7]);printw("%s","  |   ");printw(anz,g[1][8]);printw("%s","  I   "); 
mvprintw( 9, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(10, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(11, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(12, 2, "       I   ");printw(anz,g[2][0]);printw("%s","  |   ");printw(anz,g[2][1]);printw("%s","  |   ");printw(anz,g[2][2]);printw("%s","  I   ");printw(anz,g[2][3]);printw("%s","  |   ");printw(anz,g[2][4]);printw("%s","  |   ");printw(anz,g[2][5]);printw("%s","  I   ");printw(anz,g[2][6]);printw("%s","  |   ");printw(anz,g[2][7]);printw("%s","  |   ");printw(anz,g[2][8]);printw("%s","  I   "); 
mvprintw(13, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(14, 2, "       +======+======+======+======+======+======+======+======+======+");
mvprintw(15, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(16, 2, "       I   ");printw(anz,g[3][0]);printw("%s","  |   ");printw(anz,g[3][1]);printw("%s","  |   ");printw(anz,g[3][2]);printw("%s","  I   ");printw(anz,g[3][3]);printw("%s","  |   ");printw(anz,g[3][4]);printw("%s","  |   ");printw(anz,g[3][5]);printw("%s","  I   ");printw(anz,g[3][6]);printw("%s","  |   ");printw(anz,g[3][7]);printw("%s","  |   ");printw(anz,g[3][8]);printw("%s","  I   "); 
mvprintw(17, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(18, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(19, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(20, 2, "       I   ");printw(anz,g[4][0]);printw("%s","  |   ");printw(anz,g[4][1]);printw("%s","  |   ");printw(anz,g[4][2]);printw("%s","  I   ");printw(anz,g[4][3]);printw("%s","  |   ");printw(anz,g[4][4]);printw("%s","  |   ");printw(anz,g[4][5]);printw("%s","  I   ");printw(anz,g[4][6]);printw("%s","  |   ");printw(anz,g[4][7]);printw("%s","  |   ");printw(anz,g[4][8]);printw("%s","  I   "); 
mvprintw(21, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(22, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(23, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(24, 2, "       I   ");printw(anz,g[5][0]);printw("%s","  |   ");printw(anz,g[5][1]);printw("%s","  |   ");printw(anz,g[5][2]);printw("%s","  I   ");printw(anz,g[5][3]);printw("%s","  |   ");printw(anz,g[5][4]);printw("%s","  |   ");printw(anz,g[5][5]);printw("%s","  I   ");printw(anz,g[5][6]);printw("%s","  |   ");printw(anz,g[5][7]);printw("%s","  |   ");printw(anz,g[5][8]);printw("%s","  I   "); 
mvprintw(25, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(26, 2, "       +======+======+======+======+======+======+======+======+======+");
mvprintw(27, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(28, 2, "       I   ");printw(anz,g[6][0]);printw("%s","  |   ");printw(anz,g[6][1]);printw("%s","  |   ");printw(anz,g[6][2]);printw("%s","  I   ");printw(anz,g[6][3]);printw("%s","  |   ");printw(anz,g[6][4]);printw("%s","  |   ");printw(anz,g[6][5]);printw("%s","  I   ");printw(anz,g[6][6]);printw("%s","  |   ");printw(anz,g[6][7]);printw("%s","  |   ");printw(anz,g[6][8]);printw("%s","  I   "); 
mvprintw(29, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(30, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(31, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(32, 2, "       I   ");printw(anz,g[7][0]);printw("%s","  |   ");printw(anz,g[7][1]);printw("%s","  |   ");printw(anz,g[7][2]);printw("%s","  I   ");printw(anz,g[7][3]);printw("%s","  |   ");printw(anz,g[7][4]);printw("%s","  |   ");printw(anz,g[7][5]);printw("%s","  I   ");printw(anz,g[7][6]);printw("%s","  |   ");printw(anz,g[7][7]);printw("%s","  |   ");printw(anz,g[7][8]);printw("%s","  I   "); 
mvprintw(33, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(34, 2, "       +------+------+------+------+------+------+------+------+------+");
mvprintw(35, 2 ,"       I      |      |      I      |      |      I      |      |      I");   
mvprintw(36, 2, "       I   ");printw(anz,g[8][0]);printw("%s","  |   ");printw(anz,g[8][1]);printw("%s","  |   ");printw(anz,g[8][2]);printw("%s","  I   ");printw(anz,g[8][3]);printw("%s","  |   ");printw(anz,g[8][4]);printw("%s","  |   ");printw(anz,g[8][5]);printw("%s","  I   ");printw(anz,g[8][6]);printw("%s","  |   ");printw(anz,g[8][7]);printw("%s","  |   ");printw(anz,g[8][8]);printw("%s","  I   "); 
mvprintw(37, 2, "       I      |      |      I      |      |      I      |      |      I");   
mvprintw(38, 2, "       +======+======+======+======+======+======+======+======+======+");
mvprintw(40, 2, "       Moechten Sie eine andere (a) Verteilung der ");
attron(COLOR_PAIR(3));
printw("%d",nl);
attron(COLOR_PAIR(1));
printw(" leeren Felder erzeugen");
mvprintw(41, 2, "       oder in diesem Programm fortfahren? (f) ");
mvprintw(42, 2, "     (Wenn Sie  a  eingeben, werden die leeren Felder anders verteilt.)");
mvprintw(43, 2, "(Alle Varianten beruhen auf demselben, hierfuer erzeugten SUDOKU-Gesamtfeld.)");

unsigned char ent3;
ENT3:
move(41,49);
addstr(" ");
move(41,49);
ent3=getch();
switch(ent3)
{
  case 'f' : goto weiter3;    break;
  case 'a' : goto zufleer;    break;
  default  : goto ENT3; break;
}
weiter3:      
//#ifdef fhj34


mvprintw(40, 2, "              Moechten Sie dieses Sudoku-Raetsel ausdrucken? (j),                       ");
mvprintw(41, 2, "                 oder soll das Programm verlassen werden? (v)                          ");
mvprintw(42, 2, "                                                                                       ");
mvprintw(43, 2, "                                                                                       ");

unsigned char ent4;
ENT4:
move(41,64);
addstr(" ");
move(41,64);
ent4=getch();
switch(ent4)
{
  case 'j' : goto weiter4;    break;
  case 'v' : goto PgmEnd;     break;
  default  : goto ENT4; break;
}
weiter4:
clear(); 
FILE *stdprn;
stdprn=popen("lpr", "w");
fprintf(stdprn, "%s\n", "         +======+======+======+======+======+======+======+======+======+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[0][0],g[0][1],g[0][2],g[0][3],g[0][4],g[0][5],g[0][6],g[0][7],g[0][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +------+------+------+------+------+------+------+------+------+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[1][0],g[1][1],g[1][2],g[1][3],g[1][4],g[1][5],g[1][6],g[1][7],g[1][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +------+------+------+------+------+------+------+------+------+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[2][0],g[2][1],g[2][2],g[2][3],g[2][4],g[2][5],g[2][6],g[2][7],g[2][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +======+======+======+======+======+======+======+======+======+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[3][0],g[3][1],g[3][2],g[3][3],g[3][4],g[3][5],g[3][6],g[3][7],g[3][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +------+------+------+------+------+------+------+------+------+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[4][0],g[4][1],g[4][2],g[4][3],g[4][4],g[4][5],g[4][6],g[4][7],g[4][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +------+------+------+------+------+------+------+------+------+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[5][0],g[5][1],g[5][2],g[5][3],g[5][4],g[5][5],g[5][6],g[5][7],g[5][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +======+======+======+======+======+======+======+======+======+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[6][0],g[6][1],g[6][2],g[6][3],g[6][4],g[6][5],g[6][6],g[6][7],g[6][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +------+------+------+------+------+------+------+------+------+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[7][0],g[7][1],g[7][2],g[7][3],g[7][4],g[7][5],g[7][6],g[7][7],g[7][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +------+------+------+------+------+------+------+------+------+");
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "         I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I   %c  |   %c  |   %c  I\n",g[8][0],g[8][1],g[8][2],g[8][3],g[8][4],g[8][5],g[8][6],g[8][7],g[8][8]);
fprintf(stdprn, "%s\n", "         I      |      |      I      |      |      I      |      |      I");
fprintf(stdprn, "%s\n", "         +======+======+======+======+======+======+======+======+======+");
fprintf(stdprn, "%s%d%s\n", "                 Dieses SUDOKU-Raetsel enthaelt ",nl," leere Felder.");
// Die folgende Zeile sagt dem Drucker, da die Druckseite zuende ist und gedruckt werden kann.
fprintf(stdprn, "\f"); 
pclose(stdprn);
clear();
mvprintw(21,10, "Soll das Programm verlassen werden? (v) ");
mvprintw(22,10, "oder soll von dem selben vollstaendig ausgefuellten SUDOKU-Grundschema");
mvprintw(23,10, "ein weiteres SUDOKU-Raetsel mit einer anderen Anzahl freier Felder");
mvprintw(24,10, "erzeugt werden? (j) ");

unsigned char ent5;
ENT5:
move(24,30);
addstr(" ");
move(24,30);
ent5=getch();
switch(ent5)
{
  case 'j' : goto sudvers; clear(); break;
  case 'v' : goto PgmEnd;     break;
  default  : goto ENT5; break;
}

PgmEnd:
move(24,30);
addstr(" ");
endwin();
return 0;
}

// Eigene Funktionen
int zuf(int tt)
{
    randinit(tt);         // randinit(ta); sorgt dafr, da immer neue Startpositionen
    return(randomint(10));// fr den Zufallsgenerator gesetzt werden.
}
